#ifndef Lib_Property_h
#define Lib_Property_h

// Inheritance :
#include <Slash/Data/IProperty.h>

namespace Lib {

class Property : public virtual Slash::Data::IProperty {
public: //IProperty
  virtual void set(const std::string&,Slash::Data::IProperty::Type,int = 0,const std::string& = "");
  virtual std::string name() const;
  virtual std::string label() const;
  virtual std::string header() const;
  virtual void dress(std::string&) const;
  virtual Slash::Data::IProperty::Type type() const;
  virtual std::string typeString() const;
public:
  Property();
  Property(const Property&);
  Property(const std::string&,Slash::Data::IProperty::Type,int = 0,const std::string& = "");
  Property& operator =(const Property&);
  virtual ~Property();
private:
  std::string fName;
  Slash::Data::IProperty::Type fType;
  int fLength;
  std::string fLabel;
  std::string fHeader;
};

}

#endif



