#ifndef OnX_Qt_Callbacks_h
#define OnX_Qt_Callbacks_h 

// Inheritance :
#include <qobject.h>
#include <OnX/Core/Action.h>

namespace Lib {class ItemML;}
namespace OnX {class BaseUI;}

class QCallbackData;

//#if QT_VERSION < 0x040000
//class QListViewItem;
//#else
class QTreeWidgetItem;
//#endif

class QtCallback : public QObject, public OnX::Action {
  Q_OBJECT
public:
  QtCallback(Slash::UI::IUI&,
             Slash::UI::IWidget*,
             OnX::Action::NativeWidget,
             const std::string&,const std::string&,
             const OnX::Action::Parameters&,
             const std::string&,int);
  //FIXME : cp cstor.
  virtual ~QtCallback();
private:
  QtCallback(const QtCallback&);
  QtCallback& operator=(const QtCallback&);
public slots:
  void execute();
  void execute2(QCallbackData&);
  //#if QT_VERSION < 0x040000
  //NOTE : if uncommented the moc-qt4 will produce code for the below !
  //void execute3(QListViewItem*);
  //#else
  void execute3(QTreeWidgetItem*);
  //#endif
};

namespace OnX {
class CloseCallback : public QObject, public OnX::Action {
  Q_OBJECT
public:
  CloseCallback(BaseUI&,Lib::ItemML*);
  virtual ~CloseCallback();
private:
  CloseCallback(const CloseCallback&);
  CloseCallback& operator=(const CloseCallback&);
public slots:
  void execute();
private:
  BaseUI& fBaseUI;
  Lib::ItemML* fItemML;
};
}

/* NOTE : not needed.
namespace OnX {
class DestroyCallback : public QObject, public OnX::Action {
  Q_OBJECT
public:
  DestroyCallback(BaseUI&,Lib::ItemML*,QWidget*);
  virtual ~DestroyCallback();
public slots:
  void execute();
private:
  Lib::ItemML* fItemML;
  QWidget* fWidget;
};
}
*/

#endif
