#ifndef Slash_Net_INetManager_h
#define Slash_Net_INetManager_h

#include <string>
#include <vector>

namespace Slash {namespace Core { class IFileGetter;}}

namespace Slash {

namespace Net {

class INetManager {
public:
  virtual ~INetManager() {};
public:
  typedef std::pair<std::string,std::string> Option;
  typedef std::vector<Option> Options;
public:
  virtual bool isClient() const = 0;
  virtual Slash::Core::IFileGetter* fileGetter() const = 0;
  virtual bool executeScript(const std::string&,const std::string&,const Options&) = 0;
  virtual bool pushEnd(const std::string&,const std::vector<std::string>&) = 0;
  virtual bool flushEnds() = 0;
  virtual unsigned int sizeEnds() = 0;

  virtual bool waitEnd(std::string&,std::vector<std::string>&) = 0;

  virtual bool sendFile(const std::string&) = 0;

  virtual bool askFile(const std::string&) = 0;
  virtual bool waitFile(const std::string&) = 0;

  virtual bool askFileExists(const std::string&,bool&) = 0;

  virtual bool sendExit(int) = 0;

  //INTERNAL:
  virtual bool sendString(const std::string&) = 0;
  virtual bool waitString(std::string&) = 0;
};

} //Net

} //Slash

#endif
